% ADN_PRC: Constraints.

contradiction(['Contrad. class ADN1, connection', C,
   'in', ADN,
   'has a non-numeric cost attribute', TC]) :-
   o_verifyingLogMsg('ADN1'),
   attrDiNet(ADN),
   connection__e_network(C, ADN),
   cost__isAttributeOf_connection(TC, C),
   ~( number(TC) ).

contradiction(['Contrad. class ADN2, connection', C,
   'in', ADN,
   'has more than one cost attribute']) :-
   o_verifyingLogMsg('ADN2'),
   attrDiNet(ADN),
   connection__e_network(C, ADN),
   cost__isAttributeOf_connection(TC1, C),
   cost__isAttributeOf_connection(TC2, C),
   TC1 < TC2.
       % Spec of  1 to 1  association constraint.

