% ASSIGNMC.PRC


contradiction(['Contrad. class AC1', AC, SV]) :-
   o_verifyingLogMsg('AC1'),
   assignmentClass__mapsFrom_sv(AC, SV),
   propositionSet__has_cardinalNumber(
      assignmentClass__mapsFrom_sv(AC, _),
      N),
   N > 1.

contradiction(['Contrad. class AC2', AC, SV]) :-
   o_verifyingLogMsg('AC2'),
   assignmentClass__mapsTo_sv(AC, SV),
   propositionSet__has_cardinalNumber(
      assignmentClass__mapsTo_sv(AC, _),
      N),
   N > 1.

contradiction(['Contrad. class AC11', AC,
   'has a co-domain', DS1,
   'which is not a subset of its domain', DS2]) :-
   o_verifyingLogMsg('AC11'),
   assignmentClass__mapsFrom_sv(AC, SV1),
   assignmentClass__mapsTo_sv(AC, SV2),
   stateVariable__isAssociatedWith_sort(SV1, DS1),
   stateVariable__isAssociatedWith_sort(SV2, DS2),
   ~( concept__e_set(DS1, DS2) ).


