% BU.PRC: The constraints


contradiction(['Contrad. class BU1: Mapping class',MC,
   'is no element of any behavioural unit']) :-
   o_verifyingLogMsg('BU1'),
   eachInstanceOfMc__mapsFromAnInstanceOf_sv(MC,_),
   ~( mappingClass__e_bu(MC,_) ). 
     

contradiction(['Contrad. class BU2: Mapping class',MC,
   'is no element of any behavioural unit']) :-
   o_verifyingLogMsg('BU2'),
   eachInstanceOfMc__mapsToAnInstanceOf_sv(MC,_),
   ~( mappingClass__e_bu(MC,_) ).
      

contradiction(
   ['Contrad. class BU3: Mapping class',MC,
    'maps from state variable',SV,
    'which is no element of',BU]) :-
   o_verifyingLogMsg('BU3'),
   mappingClass__e_bu(MC,BU),
   eachInstanceOfMc__mapsFromAnInstanceOf_sv(MC,SV),
   ~( stateVariable__e_bu(SV,BU) ).


contradiction(
   ['Contrad. class BU4: Mapping class',MC,
    'maps to state variable',SV,
    'which is no element of',BU]) :-
   o_verifyingLogMsg('BU4'),
   mappingClass__e_bu(MC,BU),
   eachInstanceOfMc__mapsToAnInstanceOf_sv(MC,SV),
   ~( stateVariable__e_bu(SV,BU) ).


contradiction(['Contrad. class BU5: Redundant state variable',SV,
                'in',BU]) :-
   o_verifyingLogMsg('BU5'),
   stateVariable__e_bu(SV,BU),
   ~( buId__eq_autonomousSevId(BU,SV) ),
   ~( class__isExplicitlySubclassOf_class(_,SV) ),
   ~( eachInstanceOfMc__mapsFromAnInstanceOf_sv(_,SV) ),
   ~( eachInstanceOfMc__mapsToAnInstanceOf_sv(_,SV) ).




