% COMBIN.PRO: Abstractions about combinations.
% Author: Frans Meijs, 1 jan 1999.


concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   tqoSet__isCombinationOutOf_tqoSetOfSorts(C1,C2).


tqoSet__isCombinationOutOf_tqoSetOfSorts(TS,TSS) :-
   TS = [E],
   TSS = [S],
   concept__e_set(E,S).
tqoSet__isCombinationOutOf_tqoSetOfSorts(TS,TSS) :-
   TS = [H|T],
   TSS = [SH|ST],
   nonvar(SH),
   concept__e_set(H,SH),
   tqoSet__isCombinationOutOf_tqoSetOfSorts(T,ST).

