% ESMC.PRC: The constraints.

contradiction(['Contrad. class ESMC1',X,
   'does not map from a state variable']) :-
   o_verifyingLogMsg('ESMC1'),
   exists( elemStateMappingClass__mapsTo_stateVariable(X,_) ),
   ~( elemStateMappingClass__mapsFrom_stateVariable(X,_) ).


contradiction(['Contrad. class ESMC2',X,
   'does not map to a state variable']) :-
   o_verifyingLogMsg('ESMC1'),
   exists( elemStateMappingClass__mapsFrom_stateVariable(X,_) ),
   ~( elemStateMappingClass__mapsTo_stateVariable(X,_) ).


contradiction(['Contrad. class ESMC3',ESMC,
   'maps from state variable',ESV,
   'associated to sort',S,
   'which is no subset of the sort of elementaryStates']) :-
   o_verifyingLogMsg('ESMC3'),
   elemStateMappingClass__mapsFrom_stateVariable(ESMC,ESV),
   stateVariable__isAssociatedWith_sort(ESV,S),
   S \= ['SortOf','elementaryStates'],
   ~( sort__e_sort(S,['SortOf','elementaryStates']) ).


contradiction(['Contrad. class ESMC4',ESMC,
   'maps to state variable',ESV,
   'associated to sort',S,
   'which is no subset of the sort of elementaryStates']) :-
   o_verifyingLogMsg('ESMC4'),
   elemStateMappingClass__mapsTo_stateVariable(ESMC,ESV),
   stateVariable__isAssociatedWith_sort(ESV,S),
   S \= ['SortOf','elementaryStates'],
   ~( sort__e_sort(S,['SortOf','elementaryStates']) ).

