% SORT.PRO: Abstractions about sorts.
% Author: Frans Meijs, 1992

set(D) :- sort(D).

set__intersects_set(S1,S2) :-
   sort__intersects_sort(S1,S2).

concept__isExplicitlyElementOf_set(ES,D) :-
   elemState__e_sort(ES,D).


set__isExplicitlyElementOf_set(S1,S2) :-
   sort__isExplicitlyElementOf_sort(S1,S2).
                  % set__e_set(S1,S2) :- sort__e_sort(S1,S2).
                  %     is covered by this clause.
set__isExplicitlyElementOf_set(S1,S2) :-
   entity__e_sort(S1,S2).


sort__e_sort(S1,S2) :-
   sort__isExplicitlyElementOf_sort(S1,S2).
sort__e_sort(S1,S2) :-
   sort__isExplicitlyElementOf_sort(S1,S3),
   sort__e_sort(S3,S2).


