% SU_AUX.PRO: Auxiliary predicates, for querying, etc.
% Author: Frans Meijs, 1996


stateVariable__isShareableElementOf_su_otherThan_su(SV,SU) :-
   nonvar(SV),
   structuralUnit(SU),
   stateVariable__isShareableElementOf_su(SV,SU2),
   SU \= SU2.


sev__isOutputElementOf_bu(SEV,BU) :-
   nonvar(SEV),var(BU),
   signallingEventVariable(SEV),
   stateVariable__isOutputElementOf_bu(SEV,BU).
sev__isOutputElementOf_bu(SEV,BU) :-
   nonvar(BU),
   stateVariable__isOutputElementOf_bu(SEV,BU),
   signallingEventVariable(SEV).
sev__isOutputElementOf_bu(SEV,BU) :-
   nonvar(SEV),
   sev__e_msgv(SEV,MSGV),
   msgv__isOutputElementOf_su(MSGV,SU),
   behaviouralUnit__e_su(BU,SU).
sev__isOutputElementOf_bu(SEV,BU) :-
   var(SEV),nonvar(BU),
   behaviouralUnit__e_su(BU,SU),
   msgv__isOutputElementOf_su(MSGV,SU),
   sev__e_msgv(SEV,MSGV).


psvs__e_su(PSVS,SU) :-
   psvs__isExplicitlyPrivateElementOf_su(PSVS,SU).
psvs__e_su(PSVS,SU) :-
   psvs__isShareableElementOf_su(PSVS,SU).
psvs__e_su(PSVS,SU) :-
   psvs__isInputElementOf_su(PSVS,SU).   
psvs__e_su(PSVS,SU) :-
   psvs__isOutputElementOf_su(PSVS,SU).


bu__isSecondaryElementOf_su(BU,SU) :-
   nonvar(BU),
   behaviouralUnit__e_su(BU,SU2),
   structuralUnit__isExplicitlyPrivateElementOf_su(SU2,SU).
bu__isSecondaryElementOf_su(BU,SU) :-
   var(BU),nonvar(SU),
   structuralUnit__isExplicitlyPrivateElementOf_su(SU2,SU),
   behaviouralUnit__e_su(BU,SU2).

