@echo off
rem IPLM_VER_3.BAT: IPL model verifying command batch, phase 3.
rem Author: Frans A. Meijs, 7 dec 1998.

if NOT EXIST werkplaats\iplm_ver2.wrk goto errexit1

call %USERPROFILE%\init.bat

call perlf.bat %PERL_FM%\applications\iplm_ver.prl werkplaats\iplm_ver2.wrk werkplaats\iplm_vct.wrk
rem         Put clauses together, remove duplicate facts, if any.
sort werkplaats\iplm_vct.wrk > werkplaats\iplm_vct2.wrk 
call perlf.bat %PERL_FM%\applications\f_undup.prl werkplaats\iplm_vct2.wrk werkplaats\iplm_vct.pro
rem echo Diagnostics are in file werkplaats\iplm_ver.log
echo Class tree is in file werkplaats\iplm_vct.pro
goto exit

:errexit1
   echo Command ignored: a file werkplaats\iplm_ver2.wrk has to be present

:exit
pause
