@echo off
rem Iplm.ve2.bat - IPL model verifying command batch, instance level.
rem Author: Frans A. Meijs, 7 dec 1998.

rem Imported from environment: COMMAND_FM, SWIPL, IPL_FM

echo "Collecting file *.PRP in the default directory..."
copy /A *.prp ipl.wrk
call %IPL_FM%\%PROLOG_DIALECT%\iplm_prs.bat
rem         This way avoids the need of declaring these clauses "multifile".
sort ipl.wrk > iplm_ver.wr2
del ipl.wrk
call perlf.bat %COMMAND_FM%\f_undup.prl iplm_ver.wr2 iplm_ver.wrk
rem         Put clauses together, remove duplicate facts, if any.
rem         The other files are consulted, as this gives the Prolog
rem         interpreter a chance to check for unintended redefinitions.

%SWIPL%\bin\swipl.exe -f %IPL_FM%\applications\iplm_ve2.prg
rem start /w %SWIPL%\bin\plwin.exe iplm_ve2.prg
del iplm_ver.wr*
