% DN_AUX.PRO: Theories for analysis and synthesis purposes.

connection__isOriginOf_solutionPath__in_diNet(BC, SP, DN) :-
   nonvar(BC),
   path__connectedTo_connection__e_solutionPath__in_diNet([], BC, SP, DN).


path__connectedTo_connection__e_solutionPath__in_diNet(PNbut1, CNbut1, PN, DN) :-
   connection__e_network(CNbut1, DN),
   endConnection(CNbut1),
   PN = [CNbut1| PNbut1].
path__connectedTo_connection__e_solutionPath__in_diNet(PNbut1, CNbut1, PN, DN) :-
   connection__e_network(CNbut1, DN),
   connection__connectsTo_node(CNbut1, Node),
   connection__connectsFrom_node(CN, Node),
   ~( term__isMemberOf_list__v2(CN, PNbut1) ),
   path__connectedTo_connection__e_solutionPath__in_diNet([CNbut1| PNbut1], CN, PN, DN).
                                   % Depth First Search. Ref: Bratko, par. 11.2.


% To be defined, dependent on the problem to be solved: endConnection/1.
% For yielding a "leaf" path, the definition becomes:
%  endConnection(C) :-
%     connection__connectsTo_node(C, N),
%     ~( connection__connectsFrom_node(_, N) ).

% This approach implies that one type of problem at a time can be solved. 
% This is considered to be no practical limitation however.
