% ADN_AUX: Theories for analysis and synthesis.


connection__isOriginOf_solutionPath__in_attrDiNet__with_cost(BC, SP, DN, TC) :-
   nonvar(BC),
   connection__isOriginOf_solutionPath__in_diNet(BC, SP, DN),
   cost__isAttributeOf_path(TC, SP).

 
cost__isAttributeOf_path(0, P) :-
   P == [],                               % P should not unify with [].
   !.                                     % Solution is sufficient.
cost__isAttributeOf_path(TC, P) :-
   nonvar(P),
   P = [C],
   cost__isAttributeOf_connection(TC, C),
   !.                                      % Solution is sufficient.
cost__isAttributeOf_path(TC, P) :-
   nonvar(P),
   P = [C| P2],
   cost__isAttributeOf_connection(CC, C),
   cost__isAttributeOf_path(TC2, P2),
   TC is CC + TC2.


%:- consult('dn_aux.pro').
