% BMC.PRC

contradiction(['Contrad. class BMC1', X,
   'maps from more than two variables']) :-
   booleanMc__mapsFrom_booleanSv(X, _),
   propositionSet__has_cardinalNumber(
      booleanMc__mapsFrom_booleanSv(X, _),
      N),
   N > 2.

contradiction(['Contrad. class BMC2', X,
   'maps to more than one variable']) :-
   booleanMc__mapsTo_booleanSv(X, _),
   propositionSet__has_cardinalNumber(
      booleanMc__mapsTo_booleanSv(X, _),
      N),
   N > 1.

contradiction(['Contrad. class BMC11', BMC,
   'maps from non-boolean variable', BSV]) :-
   booleanMc__mapsFrom_booleanSv(BMC, BSV),
   ~(stateVariable__isAssociatedWith_sort(
                                 BSV, ['SortOf', 'booleanStates']) ).

contradiction(['Contrad. class BMC12', BMC,
   'maps to non-boolean variable', BSV]) :-
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   ~(stateVariable__isAssociatedWith_sort(
                                 BSV, ['SortOf', 'booleanStates']) ).


