% BMC.PRO: Abstractions about boolean mapping classes.


elemStateMappingClass__mapsFrom_stateVariable(BMC, BSV) :-
   booleanMc__mapsFrom_booleanSv(BMC, BSV).

elemStateMappingClass__mapsTo_stateVariable(BMC, BSV) :-
   booleanMc__mapsTo_booleanSv(BMC, BSV).


booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV1),         
   class__isExplicitlySubclassOf_class(BMC, '~'),
   BS = 'FALSE',
   state__isNextInstanceOf_stateVariable(BS, BSV).
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV1),
   class__isExplicitlySubclassOf_class(BMC, '~'),
   BS = 'TRUE',
   state__isNextInstanceOf_stateVariable(BS, BSV).         
                                                               % NOT

                                                               
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '|'),
   BS = 'FALSE',
   state__isNextInstanceOf_stateVariable(BS, BSV).
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '|'),
   BS = 'TRUE',
   state__isNextInstanceOf_stateVariable(BS, BSV). 
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '|'),
   BS = 'TRUE',
   state__isNextInstanceOf_stateVariable(BS, BSV). 
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '|'),
   BS = 'TRUE',
   state__isNextInstanceOf_stateVariable(BS, BSV). 
                                                               % OR

                                                               
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '&'),
   BS = 'FALSE',
   state__isNextInstanceOf_stateVariable(BS, BSV).
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '&'),
   BS = 'FALSE',
   state__isNextInstanceOf_stateVariable(BS, BSV).
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('FALSE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '&'),
   BS = 'FALSE',
   state__isNextInstanceOf_stateVariable(BS, BSV).
booleanState__i_booleanSv(BS, BSV) :-
   nonvar(BSV),
   booleanMc__mapsTo_booleanSv(BMC, BSV),
   booleanMc__mapsFrom_booleanSv(BMC, BSV1),
   booleanMc__mapsFrom_booleanSv(BMC, BSV2),
   id__lt_id(BSV1, BSV2),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV1),
   state__isExplicitlyInstanceOf_stateVariable('TRUE', BSV2),
   class__isExplicitlySubclassOf_class(BMC, '&'),
   BS = 'TRUE',
   state__isNextInstanceOf_stateVariable(BS, BSV).
                                                               % AND



%:- consult('bmc.prc').
%:- consult('bmc.prp').
