% CC.PRO: Abstractions about comparison classes.



eachInstanceOfMc__mapsFromAnInstanceOf_sv(CC, SV) :-
   comparisonClass__mapsFrom_sv(CC, SV).

eachInstanceOfMc__mapsToAnInstanceOf_sv(CC, SV) :-
   comparisonClass__mapsTo_booleanSv(CC, SV).

state__i_stateVariable(BS, BSV) :-
   booleanState__i_booleanSv(BS, BSV).


booleanState__i_booleanSv(BS, SV) :-
   nonvar(SV),
   comparisonClass__mapsTo_booleanSv(CC, SV),
   comparisonClass__mapsFrom_sv(CC, SV1),
   comparisonClass__mapsFrom_sv(CC, SV2),
   state__isExplicitlyInstanceOf_stateVariable(S1, SV1),
   state__isExplicitlyInstanceOf_stateVariable(S2, SV2),
   class__isExplicitlySubclassOf_class(CC, '='),
   id__lt_id(S1, S2),
   BS = 'FALSE',
   state__isNextInstanceOf_stateVariable(BS, SV).
booleanState__i_booleanSv(BS, SV) :-
   nonvar(SV),
   comparisonClass__mapsTo_booleanSv(CC, SV),
   comparisonClass__mapsFrom_sv(CC, SV1),
   comparisonClass__mapsFrom_sv(CC, SV2),
   id__lt_id(SV1, SV2),
   state__isExplicitlyInstanceOf_stateVariable(S1, SV1),
   state__isExplicitlyInstanceOf_stateVariable(S2, SV2),
   class__isExplicitlySubclassOf_class(CC, '='),
   S1 == S2,
   BS = 'TRUE',
   state__isNextInstanceOf_stateVariable(BS, SV).
booleanState__i_booleanSv(BS, SV) :-
   nonvar(SV),
   comparisonClass__mapsTo_booleanSv(CC, SV),
   comparisonClass__mapsFrom_sv(CC, SV1),
   comparisonClass__mapsFrom_sv(CC, SV2),
   id__lt_id(SV1, SV2),
   state__isExplicitlyInstanceOf_stateVariable(S1, SV1),
   state__isExplicitlyInstanceOf_stateVariable(S2, SV2),
   class__isExplicitlySubclassOf_class(CC, '~='),
   S1 == S2,
   BS = 'FALSE',
   state__isNextInstanceOf_stateVariable(BS, SV).
booleanState__i_booleanSv(BS, SV) :-
   nonvar(SV),
   comparisonClass__mapsTo_booleanSv(CC, SV),
   comparisonClass__mapsFrom_sv(CC, SV1),
   comparisonClass__mapsFrom_sv(CC, SV2),
   state__isExplicitlyInstanceOf_stateVariable(S1, SV1),
   state__isExplicitlyInstanceOf_stateVariable(S2, SV2),
   class__isExplicitlySubclassOf_class(CC, '~='),
   id__lt_id(S1, S2),
   BS = 'TRUE',
   state__isNextInstanceOf_stateVariable(BS, SV).



%:- consult('cc.prc').
%:- consult('cc.prp').

