% CONN_NET.PRC: The constraints.
% Author: Frans Meijs, 4 sep 1996.

contradiction(['Contrad. class','CONN_NET1:', CN,
   'has only a subset', ICN,
   'as connected net']) :-
   o_verifyingLogMsg('CONN_NET1'),
   connNet(CN),
      o_chars('Conn.net '),     % Detailed log.
      o_chars(CN),
      o_chars('... '), % o_eor cannot be used here because it is no IPL term.
   referenceConnection__e_network(C, CN),
   C_L = [C],
   setOfConnections__e_implicitConnNet__in_network(C_L, ICN, CN),
   list__has_length(ICN, L1),
   propositionSet__has_cardinalNumber(
                                 connection__e_network(_, CN),
                                 L2
                                 ),
   L1 < L2.

