% HIERARCH.PRC: The constraints.


contradiction(['Contrad. class','HIERARCH1',H,
   'contains a unit cycle connection',C]) :-
   o_verifyingLogMsg('HIERARCH1'),
   hierarchy(H),
   connection__e_network(C,H),
   connection__connectsFrom_node(C,N),
   connection__connectsTo_node(C,N).


contradiction(
   ['Contrad. class','HIERARCH2',HR,
   'has only a subset',IHR,
   'as hierarchy']) :-
   o_verifyingLogMsg('HIERARCH2'),
   hierarchy(HR),
      o_chars('Hierarchy '),     % Detailed log.
      o_chars(HR),
      o_chars('... '), % o_eor cannot be used here because it is no IPL term.
   referenceConnection__e_network(C,HR),
   C_L = [C],
   setOfConnections__e_implicitHierarchy__in_diNet(C_L,IHR,HR),
   list__has_length(IHR,L1),
   propositionSet__has_cardinalNumber(
                                 connection__e_network(_,HR),
                                 L2
                                 ),
   L1 < L2.


