% NETWORK.PRC

contradiction(['Contrad. class NETWORK1', C,
   'is connection in both', N1,
   'and', N2]) :-
   o_verifyingLogMsg('NETWORK1'),
   connection__e_network(C, N1),
   connection__e_network(C, N2),
   id__lt_id(N1, N2).
       % Spec of  * to <=1  association constraint.


contradiction(['Contrad. class NETWORK2: Connection', C,
   'in network', N,
   'has improper number of nodes']) :-
   o_verifyingLogMsg('NETWORK2'),
   connection__e_network(C, N),
   propositionSet__has_cardinalNumber(
      connection__connects_node(C, _),
      NN),
   NN \== 2.
       % Spec of  2 to 1  association constraint.


contradiction(['Contrad. class NETWORK3: Connection', C1,
   'and', C2,
   'are both reference in network', N]) :-
   o_verifyingLogMsg('NETWORK3'),
   referenceConnection__e_network(C1, N),
   referenceConnection__e_network(C2, N),
   id__lt_id(C1, C2).


