% OUTCOMPT.PRO: Standard theories about output composition trees.

% A composition output tree can be instantiated by a query of
% the form:

%               o_compositionTree(C).


% where C is the identification of the root class c.f. the theories in 
% STATE.PRO.


o_compositionTree(C) :-
   o_chars('Components:'), o_eor,
   o_eor,
   o_tree(C).

o_vertex__isSubordinateTo_vertex(C1, C2) :-
   state__e_entity(C1, C2).

o_leaf(C, Path_length) :-
   INDENT is Path_length * 3,
   o_spaces(INDENT), o_chars(C), o_eor.


% :- consult('outtree.pro').

