% SORT.PRC: Constraints.

contradiction(
   ['Contrad. class SORT1',D,
    'is no element of the hierarchy of sort inclusions']) :-
   o_verifyingLogMsg('SORT1'),
   sort(D),
   D \== ['SortOf','states'],
   ~( sort__isExplicitlyElementOf_sort(D,_) ).


contradiction(
   ['Contrad. class SORT3',D,
   'seems to be a sort of elem.states but is not declared as such']) :-
   o_verifyingLogMsg('SORT3'),
   elemState__e_sort(_,D),
   ~( sort(D) ).


contradiction(
   ['Contrad. class SORT4',D,
   'seems to be a sort of entities but is not declared as such']) :-
   o_verifyingLogMsg('SORT4'),
   entity__e_sort(_,D),
   ~( sort(D) ).



%:- consult('int.pro').
%:- consult('nat.pro').




