% SYMBOL.PRO: Abstractions about symbols.
% Author: Frans Meijs, 14 mar 1998.

association(Z) :- definition(Z).
structuralUnit(Z) :- symbol(Z).

concept__isAssociatedWith_concept(Z,Y) :-
   symbol__represents_concept(Z,Y).

definition(D) :-
   D = [Z|[Y]],
   symbol__represents_concept(Z,Y).

symbol__represents_concept(Z,Y) :-
   symbol__represents_association(Z,Y).

structuralUnit__isExplicitlyPrivateElementOf_su(Z,Y) :-
   symbol__isPrivateElementOf_symbol(Z,Y).

structuralUnit__isExplicitlyShareableElementOf_su(Z,Y) :-
   symbol__isShareableElementOf_symbol(Z,Y).


%:- consult('symbol.prc').


