% VECTORV.PRO: Abstractions about vector variables.
% Author: Frans Meijs, 25 dec 1998.


tqoSetElement(TQSE) :- vectorVariableElement(TQSE).
tqoSet(TQS) :- vectorVariable(TQS).


tqoSetElement__e_tqoSet(TQSE,TQS) :-
   vectorVariableElement__e_vectorVariable(TQSE,TQS).


eachInstanceOfClass__isExplicitlyElementOf_set(IC,S) :-
   stateVariable__e_vectorVariableElement(IC,S).


concept__isExplicitlyAssociatedWith_concept(C1,C2) :-
   vectorVariable__isAssociatedWith_sort(C1,C2).
   

vectorVariable__isAssociatedWith_sort(VV,S) :-
   nonvar(VV),
   ~( qoSet__e_qoSet(_,VV) ),
   vectorVariableElement__e_vectorVariable(VVE,VV),
   vectorVariableElement__isAssociatedWith_sort(VVE,S2),
   S = [S2].
vectorVariable__isAssociatedWith_sort(VV,S) :-
   nonvar(VV),
   qoSet__e_qoSet(VV2,VV),
   vectorVariableElement__e_vectorVariable(VVE,VV),
   vectorVariableElement__isAssociatedWith_sort(VVE,S2),
   S = [S2|S3],
   vectorVariable__isAssociatedWith_sort(VV2,S3).
vectorVariable__isAssociatedWith_sort(VV,S) :-
   var(VV),nonvar(S),
   S = [S2],
   vectorVariableElement__isAssociatedWith_sort(VVE,S2),
   vectorVariableElement__e_vectorVariable(VVE,VV),
   ~( qoSet__e_qoSet(_,VV) ).
vectorVariable__isAssociatedWith_sort(VV,S) :-
   var(VV),nonvar(S),
   S = [S2|S3],
   vectorVariableElement__isAssociatedWith_sort(VVE,S2),
   vectorVariableElement__e_vectorVariable(VVE,VV),
   qoSet__e_qoSet(VV2,VV),
   vectorVariable__isAssociatedWith_sort(VV2,S3).


vectorVariableElement__isAssociatedWith_sort(VVE,S) :-
   stateVariable__e_vectorVariableElement(SV,VVE),
   stateVariable__isAssociatedWith_sort(SV,S).





